import ListItemMixin from '../mixins/list-item';
import ListItem from '../list-item';
import Input from '../input';
import './index.less';

var InputItem = {
    mixins: [ListItemMixin],
    props: {
        placeHolder: {
            type: String
        },
        value: {
            type: [String, Number]
        },
        maxLenght: {
            type: Number
        }
    },
    render: function render() {
        var _this = this;

        var h = arguments[0];

        var listItemProps = {
            props: {
                title: this.title,
                required: this.required,
                rightIcon: this.$props.rightIcon,
                valuePosition: 'left',
                labelNumber: 5
            },
            on: {
                'right-icon-click': function rightIconClick() {
                    _this.$emit("right-icon-click");
                }
            }
        };
        var rightIcon = this.$slots['right-icon'] ? h(
            'div',
            { slot: 'right-icon' },
            [this.$slots['right-icon']]
        ) : null;
        return h(
            ListItem,
            listItemProps,
            [h(Input, {
                slot: 'default',
                attrs: { 'max-lenght': this.maxLenght,
                    'place-holder': this.placeHolder,
                    value: this.value
                }
            }), rightIcon]
        );
    }
};
export default InputItem;