var Input = {
    props: {
        placeHolder: {
            type: String
        },
        value: {
            type: [String, Number]
        },
        maxLenght: {
            type: Number
        },
        inputType: {
            type: String,
            "default": "text"
        },
        readonly: {
            type: Boolean
        }
    },
    methods: {
        onFocus: function onFocus() {
            this.$emit("onFocus");
        },
        onBlur: function onBlur() {
            this.$emit("onBlur");
        },
        onInput: function onInput() {
            this.$emit("onInput");
        },
        onChange: function onChange() {
            this.$emit("onChange");
        }
    },
    render: function render() {
        var h = arguments[0];

        return h(
            "div",
            { "class": "sn-input" },
            [h("input", {
                attrs: {
                    type: this.inputType,
                    maxlength: this.maxLenght,
                    placeHolder: this.placeHolder,

                    readonly: this.readonly
                },
                domProps: {
                    "value": this.value
                },
                on: {
                    "focus": this.onFocus,
                    "blur": this.onBlur,
                    "change": this.onChange,
                    "input": this.onInput
                }
            })]
        );
    }
};

export default Input;