'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _listItem = require('../mixins/list-item');

var _listItem2 = _interopRequireDefault(_listItem);

var _listItem3 = require('../list-item');

var _listItem4 = _interopRequireDefault(_listItem3);

var _input = require('../input');

var _input2 = _interopRequireDefault(_input);

require('./index.less');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var InputItem = {
    mixins: [_listItem2['default']],
    props: {
        placeHolder: {
            type: String
        },
        value: {
            type: [String, Number]
        },
        maxLenght: {
            type: Number
        }
    },
    render: function render() {
        var _this = this;

        var h = arguments[0];

        var listItemProps = {
            props: {
                title: this.title,
                required: this.required,
                rightIcon: this.$props.rightIcon,
                valuePosition: 'left',
                labelNumber: 5
            },
            on: {
                'right-icon-click': function rightIconClick() {
                    _this.$emit("right-icon-click");
                }
            }
        };
        var rightIcon = this.$slots['right-icon'] ? h(
            'div',
            { slot: 'right-icon' },
            [this.$slots['right-icon']]
        ) : null;
        return h(
            _listItem4['default'],
            listItemProps,
            [h(_input2['default'], {
                slot: 'default',
                attrs: { 'max-lenght': this.maxLenght,
                    'place-holder': this.placeHolder,
                    value: this.value
                }
            }), rightIcon]
        );
    }
};
exports['default'] = InputItem;
module.exports = exports.default;